// BusCan.cpp: implementation of the BusCan class.
//
//////////////////////////////////////////////////////////////////////
#include <windowsx.h>
#include <windows.h>
#include "CANproto.h"
#include "BusCan.h"

extern HWND hwnd2;
extern HANDLE arriver;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BusCan::BusCan()
{
		//Dfinition des messages pour vxdcan
		
					//Ouvrir le dossier driver VxD
		hCVxD = CreateFile("\\\\.\\VXDCAN.VXD", 0,0,0, CREATE_NEW, FILE_FLAG_DELETE_ON_CLOSE, 0);

		if (hCVxD == INVALID_HANDLE_VALUE)
		{
			MessageBox(hwnd2,"Erreur d'ouverture du dossier driver VxD","Erreur",MB_OK);
			//affichage d'un message d'erreur
		}
		
		//Ouvrir le bus
		if (CAN_Open())
		{
			MessageBox(hwnd2,"Erreur d'ouverture du bus","Fonction CAN_Open",MB_OK);
			//affichage d'un message d'erreur
		
		}

		//Enregistrer la fentre pour recevoir le message WM_CANPOST
		if ((NumFIFO=CAN_SetWMes(hwnd2,WM_CANPOST ))==(HANDLE) CANERROR)
		{
			MessageBox(hwnd2, "Peut pas enregistrer fentre!","Fonction CAN_SetWMes", MB_OK);
			PostQuitMessage(0);
			CloseHandle(hCVxD);
			CAN_Close();			
		}
			//	MessageBox(hwnd2,"Initialisation...","Message",MB_OK);

			//stoppe toutes communications
			//commande 0x151
			can_send.len=2;		//taille 
			can_send.arb[0]=3;
			can_send.arb[1]=0xE0;
			can_send.data[0]=1;
			can_send.data[1]=0x51;
			//envoie d'un message
			CAN_SendMessage((unsigned char *)&can_send);

			Sleep(1);


			//fixe tous les noeuds en mode polling
			//commande 0x141
			can_send.len=2;
			can_send.arb[0]=3;
			can_send.arb[1]=0xE0;
			can_send.data[0]=1;
			can_send.data[1]=0x41;
			//envoie d'un message
			CAN_SendMessage((unsigned char *)&can_send);

			Sleep(1);

			//dmarrage de la communication pour tous les noeuds
			//commande 0x150
			can_send.len=2;
			can_send.arb[0]=3;
			can_send.arb[1]=0xE0;
			can_send.data[0]=1;
			can_send.data[1]=0x50;
			CAN_SendMessage((unsigned char *)&can_send);
			Sleep(1);
		
}

BusCan::~BusCan()
{
	can_send.len=1;
	can_send.arb[0]=0xA3;
	can_send.arb[1]=0xE0;
	can_send.data[0]=0;
	CAN_SendMessage((unsigned char *)&can_send);
	Sleep(1);

	PostQuitMessage(0);
	CloseHandle(hCVxD);
	CAN_Close();
	
	
}


BusCan::Lire()
{
	can_send.len=2;
	can_send.arb[0]=0x23;
	can_send.arb[1]=0xE0;
	can_send.data[0]=1;
	can_send.data[1]=0x61;
	CAN_SendMessage((unsigned char *)&can_send);	
	
	//Sleep(1);
	WaitForSingleObject(arriver,INFINITE);
	CAN_GetMessage(NumFIFO,(unsigned char *)&can_receive);	//reception des donnes 
	ResetEvent(arriver);
	return can_receive.data[0];

}


BusCan::Ecrire(int actionneur)
{
			can_send.len=1;
			can_send.arb[0]=0xA3;
			can_send.arb[1]=0xE0;
			can_send.data[0]=actionneur;
			CAN_SendMessage((unsigned char *)&can_send);
			Sleep(1);
}

BusCan::Fermer()
{
		can_send.len=1;
		can_send.arb[0]=0xA3;
		can_send.arb[1]=0xE0;
		can_send.data[0]=0;
		CAN_SendMessage((unsigned char *)&can_send);
		Sleep(1);
}