/********************************************************/
/* File CANproto.h										*/
/*														*/
/* INCLUDE FILE FOR CAN DRIVER							*/
/* must be include in your C app to call to the driver	*/
/*														*/
/* PURPOSE : prototypes des fonctions utilisateurs		*/



#define TIMEOUT		0xFFFE

#define STDCANERROR	0xFFFFFFFF

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


 WINUSERAPI unsigned char CAN_ReadReg(unsigned char);
 WINUSERAPI void CAN_WriteReg(unsigned char , unsigned char);

 WINUSERAPI DWORD CAN_InitBoard(WORD,WORD,unsigned char,unsigned char,unsigned char);

//2
 WINUSERAPI DWORD CAN_SetObjectConfig(unsigned char *);

//3
 WINUSERAPI void CAN_SetM15Mask(unsigned char *pm);
//4

  WINUSERAPI void CAN_SetGlobalMask(unsigned char *pm);

//5
  WINUSERAPI DWORD CAN_GetStatus(void);


//Fifo contro
//6
// reserved
 WINUSERAPI DWORD CAN_GetInfo(void );


//7
 WINUSERAPI void CAN_ClearFIFO(HANDLE);
//8
  WINUSERAPI DWORD CAN_GetPendingCount(HANDLE);
//Message
//9
  WINUSERAPI DWORD CAN_GetRecNumber(HANDLE);
//10

  WINUSERAPI DWORD CAN_GetLostNumber(HANDLE);
//11
 WINUSERAPI DWORD CAN_GetMessage(HANDLE,unsigned char *);
//12

  WINUSERAPI DWORD  CAN_SendMessage(unsigned char *);


// DWORD WINAPI  CAN_SendMessage(unsigned char *);

//Hardware related       NOT a USER FUNCTIONS


  WINUSERAPI HANDLE CAN_SetWMes(HWND hw, UINT p2);



 WINUSERAPI HANDLE CAN_SetProc(void(*userproc)(unsigned int));

 WINUSERAPI  DWORD CAN_Open(void);
 WINUSERAPI DWORD CAN_Close(void);

 WINUSERAPI DWORD  CAN_DeleteHandle(HANDLE hw);

 WINUSERAPI DWORD CAN_RequestRemoteFrame(HANDLE,unsigned char *);

 WINUSERAPI DWORD CAN_QueryRTRStatus(HANDLE);
 WINUSERAPI DWORD CAN_GetDLLvers(void);
 
#ifdef __cplusplus
}
#endif  /* __cplusplus */












